#!/usr/bin/python

from reportlab.platypus import SimpleDocTemplate, Paragraph, Spacer
from reportlab.lib.styles import getSampleStyleSheet
from reportlab.rl_config import defaultPageSize
from reportlab.lib.units import inch
import time
PAGE_HEIGHT=defaultPageSize[1]
PAGE_WIDTH=defaultPageSize[0]
styles = getSampleStyleSheet()

pageinfo = "Created by liquid weather ++ - www.liquidweather.net - " + time.strftime("%I:%M:%S %p on %d %b %Y", time.localtime())

def currentOnly(canvas, doc):
    label = ["Temperature:","Sky Conditions:","Humidity:","Wind Direction/Speed:","Pressure:","Visibility:","Cloud Cover:","UV Index:"]
    data = ["temp but feels like real temp","sky conditions data","humidity data","speed from the direction","change at current","visibility data","cloud cover data","UV data"]
    Title = "Current Conditions - Liquid Weather ++"
    xStartPosData = 3.0
    canvas.saveState()
    canvas.setFont('Helvetica-Bold',16)
    canvas.drawCentredString(PAGE_WIDTH/2.0, PAGE_HEIGHT-72.0, Title)
    canvas.setFont('Helvetica-Bold',14)
    canvas.drawString(inch, PAGE_HEIGHT-129.0,"Current weather for:")
    canvas.drawString(xStartPosData*inch, PAGE_HEIGHT-129.0,"Wellington")
    canvas.drawString(inch, PAGE_HEIGHT-144.0,"Time checked:")
    canvas.drawString(xStartPosData*inch, PAGE_HEIGHT-144.0,"date at time")
    yStartPos = 174.0
    canvas.setFont('Helvetica-Bold',11)
    for i in range(len(label)):
        canvas.drawString(inch, PAGE_HEIGHT-yStartPos,label[i])
        yStartPos += 15
    yStartPos = 174.0
    canvas.setFont('Helvetica',11)
    for i in range(len(label)):
        canvas.drawString(xStartPosData*inch, PAGE_HEIGHT-yStartPos,data[i])
        yStartPos += 15
    canvas.setFont('Helvetica',9)
    canvas.drawString(inch, 0.75 * inch, pageinfo)
    canvas.restoreState()

def forecastOnly(canvas, doc):
    label = ["Temperature (Low):","Temperature (High):","Sky Conditions:","Chance Of Rain"]
    data = ["temp low","temp high","sky conditions data","chance of rain"]
    Title = "5 day forecast - Liquid Weather ++"
    xStartPosData = 3.0
    canvas.saveState()
    canvas.setFont('Helvetica-Bold',16)
    canvas.drawCentredString(PAGE_WIDTH/2.0, PAGE_HEIGHT-72.0, Title)
    canvas.setFont('Helvetica-Bold',14)
    canvas.drawString(inch, PAGE_HEIGHT-129.0,"5 day forecast for:")
    canvas.drawString(xStartPosData*inch, PAGE_HEIGHT-129.0,"Wellington")
    canvas.drawString(inch, PAGE_HEIGHT-144.0,"Time checked:")
    canvas.drawString(xStartPosData*inch, PAGE_HEIGHT-144.0,"date at time")
    baseStartPos = 174.0
    for j in range(5):
        yStartPos = baseStartPos
        canvas.setFont('Helvetica-Bold',12)
        canvas.drawString(inch, PAGE_HEIGHT-yStartPos, "Forecast for:")
        canvas.drawString(xStartPosData*inch, PAGE_HEIGHT-yStartPos, "day and date")
        canvas.setFont('Helvetica-Bold',11)
        yStartPos += 20
        for i in range(len(label)):
            canvas.drawString(inch, PAGE_HEIGHT-yStartPos,label[i])
            yStartPos += 15
        yStartPos = baseStartPos + 20
        xStartPosData = 3.0
        canvas.setFont('Helvetica',11)
        for i in range(len(label)):
            canvas.drawString(xStartPosData*inch, PAGE_HEIGHT-yStartPos,data[i])
            yStartPos += 15
        canvas.setFont('Helvetica',9)
        canvas.drawString(inch, 0.75 * inch, pageinfo)
        baseStartPos += 100
    canvas.restoreState()

def currentForecast(canvas, doc):
    label = ["Temperature:","Sky Conditions:","Humidity:","Wind Direction/Speed:","Pressure:","Visibility:","Cloud Cover:","UV Index:"]
    data = ["temp but feels like real temp","sky conditions data","humidity data","speed from the direction","change at current","visibility data","cloud cover data","UV data"]
    for_label = ["Temperature (Low):","Temperature (High):","Sky Conditions:","Chance Of Rain"]
    for_data = ["temp low","temp high","sky conditions data","chance of rain"]
    Title = "Current Conditions and 5 Day Forecast - Liquid Weather ++"
    xStartPosData = 3.0
    canvas.saveState()
    canvas.setFont('Helvetica-Bold',16)
    canvas.drawCentredString(PAGE_WIDTH/2.0, PAGE_HEIGHT-72.0, Title)
    canvas.setFont('Helvetica-Bold',14)
    canvas.drawString(inch, PAGE_HEIGHT-100.0,"Current weather for:")
    canvas.drawString(xStartPosData*inch, PAGE_HEIGHT-100.0,"Wellington")
    canvas.drawString(inch, PAGE_HEIGHT-115.0,"Time checked:")
    canvas.drawString(xStartPosData*inch, PAGE_HEIGHT-115.0,"date at time")
    yStartPos = 140.0
    canvas.setFont('Helvetica-Bold',11)
    for i in range(len(label)):
        canvas.drawString(inch, PAGE_HEIGHT-yStartPos,label[i])
        yStartPos += 15
    yStartPos = 140.0
    canvas.setFont('Helvetica',11)
    for i in range(len(label)):
        canvas.drawString(xStartPosData*inch, PAGE_HEIGHT-yStartPos,data[i])
        yStartPos += 15
    yStartPos += 10
    canvas.setFont('Helvetica-Bold',14)
    canvas.drawString(inch, PAGE_HEIGHT-yStartPos,"5 day forecast")
    baseStartPos = yStartPos + 20
    for j in range(5):
        yStartPos = baseStartPos
        canvas.setFont('Helvetica-Bold',12)
        canvas.drawString(inch, PAGE_HEIGHT-yStartPos, "Forecast for:")
        canvas.drawString(xStartPosData*inch, PAGE_HEIGHT-yStartPos, "day and date")
        canvas.setFont('Helvetica-Bold',11)
        yStartPos += 20
        for i in range(len(for_label)):
            canvas.drawString(inch, PAGE_HEIGHT-yStartPos,for_label[i])
            yStartPos += 15
        yStartPos = baseStartPos + 20
        xStartPosData = 3.0
        canvas.setFont('Helvetica',11)
        for i in range(len(for_label)):
            canvas.drawString(xStartPosData*inch, PAGE_HEIGHT-yStartPos,for_data[i])
            yStartPos += 15
        canvas.setFont('Helvetica',9)
        canvas.drawString(inch, 0.75 * inch, pageinfo)
        baseStartPos += 100
    canvas.setFont('Helvetica',9)
    canvas.drawString(inch, 0.75 * inch, pageinfo)
    canvas.restoreState()


doc = SimpleDocTemplate("/home/matt/tmp/lwp.pdf")
Story = [Spacer(1,2*inch)]
style = styles["Normal"]
doc.build(Story, onFirstPage=forecastOnly)